﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Public Class Form1

    Dim ControlClient As Socket
    Dim DataClient As Socket

    Dim ControlReceivebuffer(29) As Byte
    Dim receivedProperties As boxcntrl

    Dim DataReceiveBuffer(511) As Byte
    Dim DataReceiveString As String

    Private Delegate Sub DelegateSub()


    Private Sub cb_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_connect.Click

        ControlClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
        Try
            If tb_RemoteIP.Text <> "" And tb_RemotePort.Text <> "" And tb_ControlPort.Text <> "" Then
                Dim ControlEP As New IPEndPoint(IPAddress.Parse(tb_RemoteIP.Text), CInt(Val(tb_ControlPort.Text)))
                Dim DataEP As New IPEndPoint(IPAddress.Parse(tb_RemoteIP.Text), CInt(Val(tb_RemotePort.Text)))

                closeconnection()

                ControlClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                DataClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)

                bt_connect.Enabled = False

                ControlClient.BeginConnect(ControlEP, New AsyncCallback(AddressOf callback_ControlConnection_connect), ControlClient)
                DataClient.BeginConnect(DataEP, New AsyncCallback(AddressOf callback_DataConnection_connect), DataClient)

            Else
                Me.sb_status.Text = "IP and Ports needed!"
            End If
        Catch ex As Exception
            Me.sb_status.Text = "Connection not possible!"
        End Try

    End Sub

    Private Sub callback_ControlConnection_connect(ByVal ar As IAsyncResult)

        Try
            ControlClient.EndConnect(ar)
            Invoke(New DelegateSub(AddressOf set_enable))
            ControlClient.BeginReceive(ControlReceivebuffer, 0, 30, SocketFlags.None, New AsyncCallback(AddressOf callback_ControlConnection_readdata), ControlClient)

            Try
                Dim ZeroByte() As Byte = {0}
                ControlClient.Send(ZeroByte, 1, SocketFlags.None)
            Catch ex As Exception
                Me.sb_status.Text = "Error while sending"
            End Try

        Catch ex As Exception
            closeconnection()
            Me.sb_status.Text = "Error while connecting to Control-Port!"
        End Try

    End Sub

    Private Sub callback_DataConnection_connect(ByVal ar As IAsyncResult)

        Try
            DataClient.EndConnect(ar)
            Invoke(New DelegateSub(AddressOf connect_enable))
            DataClient.BeginReceive(DataReceiveBuffer, 0, 511, SocketFlags.None, New AsyncCallback(AddressOf callback_DataConnection_readdata), DataClient)
        Catch ex As Exception
            closeconnection()
            Me.sb_status.Text = "Error while connecting to Remote-Port!"
        End Try

    End Sub

    Private Sub callback_ControlConnection_readdata(ByVal ar As IAsyncResult)

        If Not ControlClient Is Nothing Then
            If ControlClient.Connected Then
                Dim bytesread As Integer

                Try
                    bytesread = ControlClient.EndReceive(ar)
                    Me.Invoke(New DelegateSub(AddressOf setControl))
                    Array.Clear(ControlReceivebuffer, 0, 29)
                    ControlClient.BeginReceive(ControlReceivebuffer, 0, 30, SocketFlags.None, New AsyncCallback(AddressOf callback_ControlConnection_readdata), ControlClient)
                Catch ex As Exception
                    bytesread = 0
                End Try

                If bytesread = 0 Then
                    closeconnection()
                End If
            End If
        End If

    End Sub

    Private Sub callback_DataConnection_readdata(ByVal ar As IAsyncResult)

        If Not DataClient Is Nothing Then
            If DataClient.Connected Then
                Dim bytesread As Integer

                Try
                    bytesread = DataClient.EndReceive(ar)
                    Me.DataReceiveString = Encoding.ASCII.GetString(DataReceiveBuffer)
                    Me.Invoke(New DelegateSub(AddressOf setText))
                    Array.Clear(DataReceiveBuffer, 0, 511)
                    DataClient.BeginReceive(DataReceiveBuffer, 0, 511, SocketFlags.None, New AsyncCallback(AddressOf callback_DataConnection_readdata), DataClient)
                Catch ex As Exception
                    bytesread = 0
                End Try

                If bytesread = 0 Then
                    closeconnection()
                End If
            End If
        End If

    End Sub

    Private Sub closeconnection()

        Try

            If ControlClient.Connected Then ControlClient.Shutdown(SocketShutdown.Both)
            ControlClient.Close()
            ControlClient = Nothing

            If DataClient.Connected Then DataClient.Shutdown(SocketShutdown.Both)
            DataClient.Close()
            DataClient = Nothing
        Catch ex As Exception
            Me.sb_status.Text = "Not able to disconnect"
        End Try
        Invoke(New DelegateSub(AddressOf disconnect_enable))

    End Sub

    Private Sub cb_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_disconnect.Click

        closeconnection()

    End Sub

    Private Sub set_enable()

        Me.bt_set.Enabled = True

    End Sub

    Private Sub connect_enable()

        bt_connect.Enabled = False
        bt_disconnect.Enabled = True
        sb_status.Text = "Connected to " + tb_RemoteIP.Text + ":" + tb_RemotePort.Text

    End Sub

    Private Sub disconnect_enable()

        bt_connect.Enabled = True
        bt_disconnect.Enabled = False
        bt_set.Enabled = False
        sb_status.Text = "No Connection"

    End Sub

    Private Sub setControl()

        Me.receivedProperties = New boxcntrl(ControlReceivebuffer)
        Me.co_baudrate.Text = Me.receivedProperties.getBaud().ToString.Remove(0, 1)

        If (Me.receivedProperties.bits And &H8) = 0 Then
            Me.co_parity.Text = "none"
        Else
            If (Me.receivedProperties.bits And &H10) = 0 Then
                Me.co_parity.Text = "odd"
            Else
                Me.co_parity.Text = "even"
            End If
        End If

        If (Me.receivedProperties.bits And &H3) = 3 Then
            Me.co_databits.Text = "8"
        Else
            Me.co_databits.Text = "7"
        End If

        If (Me.receivedProperties.bits And &H4) = 4 Then
            Me.co_stopbits.Text = "2"
        Else
            Me.co_stopbits.Text = "1"
        End If

        Select Case (Me.receivedProperties.f_flags And &H3CFF)
            Case &H3003
                Me.co_handshake.Text = "none"
            Case &H91
                Me.co_handshake.Text = "RTS/CTS"
            Case &H3C0F
                Me.co_handshake.Text = "XON/XOFF"
            Case Else
                Me.co_handshake.Text = "special"
        End Select

    End Sub

    Private Sub setText()

        Me.tb_receiveData.Text &= Me.DataReceiveString

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        For Each item As String In [Enum].GetNames(GetType(boxcntrl.baudTable))
            Me.co_baudrate.Items.Add(item.Remove(0, 1))
        Next

        Me.co_parity.Items.Add("none")
        Me.co_parity.Items.Add("odd")
        Me.co_parity.Items.Add("even")

        Me.co_databits.Items.Add("8")
        Me.co_databits.Items.Add("7")

        Me.co_stopbits.Items.Add("2")
        Me.co_stopbits.Items.Add("1")

        Me.co_handshake.Items.Add("none")
        Me.co_handshake.Items.Add("RTS/CTS")
        Me.co_handshake.Items.Add("XON/XOFF")
        Me.co_handshake.Items.Add("special")

    End Sub

    Private Sub bt_set_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_set.Click

        Try
            Dim tmp_Properties As boxcntrl = Me.receivedProperties
            Dim selectedBaud As Byte = [Enum].Parse(GetType(boxcntrl.baudTable), "b" & Me.co_baudrate.SelectedItem)

            tmp_Properties.baud_fifo = tmp_Properties.baud_fifo And &HE0
            tmp_Properties.baud_fifo = tmp_Properties.baud_fifo Or selectedBaud

            If co_parity.Text = "none" Then
                tmp_Properties.bits = tmp_Properties.bits And &HF7
            Else
                tmp_Properties.bits = tmp_Properties.bits Or &H8
                If co_parity.Text = "odd" Then
                    tmp_Properties.bits = tmp_Properties.bits And &HEF
                Else
                    tmp_Properties.bits = tmp_Properties.bits Or &H10
                End If
            End If

            tmp_Properties.bits = tmp_Properties.bits Or &H3
            If co_databits.Text = "7" Then
                tmp_Properties.bits = tmp_Properties.bits And &HFE
            End If
            If co_stopbits.Text = "2" Then
                tmp_Properties.bits = tmp_Properties.bits Or &H4
            Else
                tmp_Properties.bits = tmp_Properties.bits And &HFB
            End If

            tmp_Properties.f_flags = &HC300
            Select Case co_handshake.Text
                Case "none"
                    tmp_Properties.f_flags = tmp_Properties.f_flags Or &H3003
                Case "RTS/CTS"
                    tmp_Properties.f_flags = tmp_Properties.f_flags Or &H91
                Case "XON/XOFF"
                    tmp_Properties.f_flags = tmp_Properties.f_flags Or &H3C0F
            End Select

            tmp_Properties.commands = 2
            ControlClient.Send(tmp_Properties.getBytes, 30, SocketFlags.None)
        Catch ex As Exception
            Me.sb_status.Text = "Error while setting"
        End Try

    End Sub

    Private Sub cb_sendData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_sendData.Click

        Try
            Dim sendstring As String
            Dim outbuffer As Byte()

            sendstring = Me.tb_sendData.Text

            If Me.cb_CRLF.Checked Then
                sendstring &= Chr(13) & Chr(10)
            End If

            outbuffer = System.Text.Encoding.ASCII.GetBytes(sendstring)
            DataClient.Send(outbuffer, outbuffer.Length, SocketFlags.None)
        Catch ex As Exception
            Me.sb_status.Text = "Error while sending"
        End Try

    End Sub
End Class


Public Class boxcntrl

    Public zero1 As Byte
    Public com_error As UInt16
    Public com_flags As UInt16
    Public inque As UInt16
    Public outque As UInt16
    Public baud_fifo As Byte
    Public bits As Byte
    Public rls_timeout As UInt16
    Public cts_timeout As UInt16
    Public dsr_timeout As UInt16
    Public xon_char As Byte
    Public xoff_char As Byte
    Public hs_on_limit As UInt16
    Public hs_off_limit As UInt16
    Public pe_char As Byte
    Public commands As Byte
    Public hs_flags As UInt16
    Public f_flags As UInt16
    Public zero2 As Byte


    Public Enum baudTable As Byte

        b230400 = 11
        b153600 = 14
        b115200 = 15
        b57600 = 0
        b38400 = 1
        b19200 = 2
        b9600 = 3
        b4800 = 5
        b2400 = 6
        b1200 = 7
        b600 = 8
        b300 = 9
        b150 = 10
        b110 = 16
        b75 = 12
        b50 = 13

    End Enum


    Sub New(ByVal data As Byte())

        Me.zero1 = data(0)
        Me.com_error = BitConverter.ToUInt16(data, 1)
        Me.com_flags = BitConverter.ToUInt16(data, 3)
        Me.inque = BitConverter.ToUInt16(data, 5)
        Me.outque = BitConverter.ToUInt16(data, 7)
        Me.baud_fifo = data(9)
        Me.bits = data(10)
        Me.rls_timeout = BitConverter.ToUInt16(data, 11)
        Me.cts_timeout = BitConverter.ToUInt16(data, 13)
        Me.dsr_timeout = BitConverter.ToUInt16(data, 15)
        Me.xon_char = data(17)
        Me.xoff_char = data(18)
        Me.hs_on_limit = BitConverter.ToUInt16(data, 19)
        Me.hs_off_limit = BitConverter.ToUInt16(data, 21)
        Me.pe_char = data(23)
        Me.commands = data(24)
        Me.hs_flags = BitConverter.ToUInt16(data, 25)
        Me.f_flags = BitConverter.ToUInt16(data, 27)
        Me.zero2 = data(29)

    End Sub

    Public Function getBytes() As Byte()
        Dim data(29) As Byte

        data(0) = Me.zero1
        Array.Copy(BitConverter.GetBytes(Me.com_error), 0, data, 1, 2)
        Array.Copy(BitConverter.GetBytes(Me.com_flags), 0, data, 4, 2)
        Array.Copy(BitConverter.GetBytes(Me.inque), 0, data, 6, 2)
        Array.Copy(BitConverter.GetBytes(Me.outque), 0, data, 8, 2)
        data(9) = Me.baud_fifo
        data(10) = Me.bits
        Array.Copy(BitConverter.GetBytes(Me.rls_timeout), 0, data, 11, 2)
        Array.Copy(BitConverter.GetBytes(Me.cts_timeout), 0, data, 13, 2)
        Array.Copy(BitConverter.GetBytes(Me.dsr_timeout), 0, data, 15, 2)
        data(17) = Me.xon_char
        data(18) = Me.xoff_char
        Array.Copy(BitConverter.GetBytes(Me.hs_on_limit), 0, data, 19, 2)
        Array.Copy(BitConverter.GetBytes(Me.hs_off_limit), 0, data, 21, 2)
        data(23) = Me.pe_char
        data(24) = Me.commands
        Array.Copy(BitConverter.GetBytes(Me.hs_flags), 0, data, 25, 2)
        Array.Copy(BitConverter.GetBytes(Me.f_flags), 0, data, 27, 2)
        data(29) = Me.zero2

        Return data
    End Function

    Public Function getBaud() As baudTable

        Return (31 And Me.baud_fifo)

    End Function
End Class
